Index: /BAORadio/libindi/libindi/drivers/telescope/lx200basic.cpp
===================================================================
--- /BAORadio/libindi/libindi/drivers/telescope/lx200basic.cpp	(revision 500)
+++ /BAORadio/libindi/libindi/drivers/telescope/lx200basic.cpp	(revision 501)
@@ -163,6 +163,7 @@
    IDLog("Driver Version: 2007-09-28\n");
  
-   //enableSimulation(true);  
-}
+   enable_simulation(false);  
+
+ }
 
 /**************************************************************************************
@@ -342,5 +343,5 @@
            #endif
 	   
-	   if ( (error_code = setObjectRA(fd, newRA)) < 0 || ( error_code = setObjectDEC(fd, newDEC)) < 0)
+	   if (!simulation && ( (error_code = setObjectRA(fd, newRA)) < 0 || ( error_code = setObjectDEC(fd, newDEC)) < 0))
 	   {
 	     handle_error(&EquatorialCoordsWNP, error_code, "Setting RA/DEC");
@@ -574,5 +575,5 @@
 void LX200Basic::ISPoll()
 {	
-	if (is_connected() == false)
+	if (is_connected() == false || simulation)
 	 return;
 
@@ -684,5 +685,5 @@
 	  }
 
-	  if ((error_code = Slew(fd)))
+	  if ( !simulation && (error_code = Slew(fd)))
 	  {
 	    slew_error(error_code);
@@ -716,5 +717,5 @@
 	  if (dx >= (TrackAccuracyN[0].value/(60.0*15.0)) || (dy >= TrackAccuracyN[1].value/60.0)) 
 	  {
-          	if ((error_code = Slew(fd)))
+          	if ( !simulation && (error_code = Slew(fd)))
 	  	{
 	    		slew_error(error_code);
@@ -751,8 +752,14 @@
 	  EquatorialCoordsWNP.s = IPS_IDLE;
 	   
-	  if ( ( error_code = Sync(fd, syncString) < 0) )
+	  if ( !simulation && ( error_code = Sync(fd, syncString) < 0) )
 	  {
 	        IDSetNumber( &EquatorialCoordsWNP , "Synchronization failed.");
 		return false;
+	  }
+
+	  if (simulation)
+	  {
+             EquatorialCoordsRN[0].value = EquatorialCoordsWN[0].value;
+             EquatorialCoordsRN[1].value = EquatorialCoordsWN[1].value;
 	  }
 
Index: /BAORadio/libindi/libindi/drivers/telescope/lx200generic.cpp
===================================================================
--- /BAORadio/libindi/libindi/drivers/telescope/lx200generic.cpp	(revision 500)
+++ /BAORadio/libindi/libindi/drivers/telescope/lx200generic.cpp	(revision 501)
@@ -165,4 +165,5 @@
  Property: Movement (Arrow keys on handset). West/East
 *********************************************/
+
 static ISwitch MovementWES[]       = {{"MOTION_WEST", "West", ISS_OFF, 0, 0}, {"MOTION_EAST", "East", ISS_OFF, 0, 0}};
 ISwitchVectorProperty MovementWESP      = { mydev, "TELESCOPE_MOTION_WE", "West/East", MOTION_GROUP, IP_RW, ISR_1OFMANY, 0, IPS_IDLE, MovementWES, NARRAY(MovementWES), "", 0};
@@ -314,4 +315,5 @@
   strcpy(TimeTP.device , newName );
   strcpy(UTCOffsetNP.device , newName );
+
   strcpy(SDTimeNP.device , newName );
 
@@ -338,4 +340,5 @@
 {
   static int isInit=0;
+  char *envDev = getenv("INDIDEV");
 
  if (isInit)
@@ -355,9 +358,17 @@
   {
      fprintf(stderr , "initilizaing from LX200 classic device...\n");
-     // 1. mydev = device_name
-     changeAllDeviceNames("LX200 Classic");
-     // 2. device = sub_class
+
      telescope = new LX200Classic();
-     telescope->setCurrentDeviceName("LX200 Classic");
+     if (envDev != NULL)
+     {
+         changeAllDeviceNames(envDev);
+         telescope->setCurrentDeviceName(envDev);
+     }
+     else
+     {
+        // 1. mydev = device_name
+        changeAllDeviceNames("LX200 Classic");
+        telescope->setCurrentDeviceName("LX200 Classic");
+     }
 
      MaxReticleFlashRate = 3;
@@ -367,9 +378,22 @@
   {
      fprintf(stderr , "initilizaing from LX200 GPS device...\n");
-     // 1. mydev = device_name
-     changeAllDeviceNames("LX200 GPS");
+
      // 2. device = sub_class
      telescope = new LX200GPS();
-     telescope->setCurrentDeviceName("LX200 GPS");
+
+     if (envDev != NULL)
+     {
+         // 1. mydev = device_name
+         changeAllDeviceNames(envDev);
+         telescope->setCurrentDeviceName(envDev);
+     }
+     else
+     {
+         // 1. mydev = device_name
+         changeAllDeviceNames("LX200 GPS");
+         telescope->setCurrentDeviceName("LX200 GPS");
+     }
+
+
 
      MaxReticleFlashRate = 9;
@@ -379,9 +403,19 @@
 
     IDLog("Initilizaing from LX200 16 device...\n");
-    // 1. mydev = device_name
-    changeAllDeviceNames("LX200 16");
+
     // 2. device = sub_class
    telescope = new LX200_16();
-   telescope->setCurrentDeviceName("LX200 16");
+
+   if (envDev != NULL)
+   {
+       // 1. mydev = device_name
+       changeAllDeviceNames(envDev);
+       telescope->setCurrentDeviceName(envDev);
+   }
+   else
+   {
+       changeAllDeviceNames("LX200 16");
+       telescope->setCurrentDeviceName("LX200 16");
+   }
 
    MaxReticleFlashRate = 3;
@@ -391,9 +425,19 @@
    fprintf(stderr , "initilizaing from autostar device...\n");
   
-   // 1. change device name
-   changeAllDeviceNames("LX200 Autostar");
    // 2. device = sub_class
    telescope = new LX200Autostar();
-   telescope->setCurrentDeviceName("LX200 Autostar");
+
+   if (envDev != NULL)
+   {
+       // 1. change device name
+       changeAllDeviceNames(envDev);
+       telescope->setCurrentDeviceName(envDev);
+   }
+   else
+   {
+       // 1. change device name
+       changeAllDeviceNames("LX200 Autostar");
+       telescope->setCurrentDeviceName("LX200 Autostar");
+   }
 
    MaxReticleFlashRate = 9;
@@ -403,9 +447,21 @@
    fprintf(stderr , "initilizaing from ap device...\n");
   
-   // 1. change device name
-   changeAllDeviceNames("LX200 Astro-Physics");
+
    // 2. device = sub_class
    telescope = new LX200AstroPhysics();
-   telescope->setCurrentDeviceName("LX200 Astro-Physics");
+
+   if (envDev != NULL)
+   {
+       // 1. change device name
+       changeAllDeviceNames(envDev);
+       telescope->setCurrentDeviceName(envDev);
+   }
+   else
+   {
+       // 1. change device name
+       changeAllDeviceNames("LX200 Astro-Physics");
+        telescope->setCurrentDeviceName("LX200 Astro-Physics");
+    }
+
 
    MaxReticleFlashRate = 9;
@@ -415,5 +471,18 @@
  {
   telescope = new LX200Generic();
-  telescope->setCurrentDeviceName("LX200 Generic");
+
+  if (envDev != NULL)
+  {
+      // 1. change device name
+      changeAllDeviceNames(envDev);
+      telescope->setCurrentDeviceName(envDev);
+  }
+  else
+  {
+      // 1. change device name
+      changeAllDeviceNames("LX200 Generic");
+      telescope->setCurrentDeviceName("LX200 Generic");
+  }
+
  }
 
Index: /BAORadio/libindi/libindi/examples/tutorial_four.cpp
===================================================================
--- /BAORadio/libindi/libindi/examples/tutorial_four.cpp	(revision 501)
+++ /BAORadio/libindi/libindi/examples/tutorial_four.cpp	(revision 501)
@@ -0,0 +1,292 @@
+#if 0
+    MyScope - Tutorial Four
+    Demonstration of libindi v0.7 capabilities.
+
+    Copyright (C) 2010 Jasem Mutlaq (mutlaqja@ikarustech.com)
+
+    This library is free software; you can redistribute it and/or
+    modify it under the terms of the GNU Lesser General Public
+    License as published by the Free Software Foundation; either
+    version 2.1 of the License, or (at your option) any later version.
+
+    This library is distributed in the hope that it will be useful,
+    but WITHOUT ANY WARRANTY; without even the implied warranty of
+    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
+    Lesser General Public License for more details.
+
+    You should have received a copy of the GNU Lesser General Public
+    License along with this library; if not, write to the Free Software
+    Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301  USA
+
+#endif
+
+#include <stdio.h>
+#include <stdlib.h>
+#include <string.h>
+#include <stdarg.h>
+#include <math.h>
+#include <unistd.h>
+#include <time.h>
+#include <memory>
+#include <sys/types.h>
+#include <sys/stat.h>
+
+#include <config.h>
+
+#include "indibase/baseclient.h"
+
+/* INDI Common Library Routines */
+#include "indicom.h"
+
+/* Our driver header */
+#include "tutorial_four.h"
+
+using namespace std;
+
+/* Our telescope auto pointer */
+auto_ptr<MyScope> telescope(0);
+
+const int POLLMS = 1000;				// Period of update, 1 second.
+
+/**************************************************************************************
+** Send client definitions of all properties.
+***************************************************************************************/
+void ISInit()
+{
+ static int isInit=0;
+
+ if (isInit)
+  return;
+
+ if (telescope.get() == 0)
+ {
+     isInit = 1;
+     telescope.reset(new MyScope());
+ }
+ 
+}
+
+/**************************************************************************************
+**
+***************************************************************************************/
+void ISGetProperties (const char *dev)
+{
+ ISInit(); 
+ telescope->ISGetProperties(dev);
+}
+
+/**************************************************************************************
+**
+***************************************************************************************/
+void ISNewSwitch (const char *dev, const char *name, ISState *states, char *names[], int n)
+{
+ ISInit();
+ telescope->ISNewSwitch(dev, name, states, names, n);
+}
+
+/**************************************************************************************
+**
+***************************************************************************************/
+void ISNewText (const char *dev, const char *name, char *texts[], char *names[], int n)
+{
+ ISInit();
+ telescope->ISNewText(dev, name, texts, names, n);
+}
+
+/**************************************************************************************
+**
+***************************************************************************************/
+void ISNewNumber (const char *dev, const char *name, double values[], char *names[], int n)
+{
+ ISInit();
+ telescope->ISNewNumber(dev, name, values, names, n);
+}
+
+/**************************************************************************************
+**
+***************************************************************************************/
+void ISNewBLOB (const char *dev, const char *name, int sizes[], int blobsizes[], char *blobs[], char *formats[], char *names[], int n)
+{
+  INDI_UNUSED(dev);
+  INDI_UNUSED(name);
+  INDI_UNUSED(sizes);
+  INDI_UNUSED(blobsizes);
+  INDI_UNUSED(blobs);
+  INDI_UNUSED(formats);
+  INDI_UNUSED(names);
+  INDI_UNUSED(n);
+}
+
+/**************************************************************************************
+**
+***************************************************************************************/
+void ISSnoopDevice (XMLEle *root) 
+{
+  INDI_UNUSED(root);
+}
+
+/**************************************************************************************
+** LX200 Basic constructor
+***************************************************************************************/
+MyScope::MyScope()
+{
+    IDLog("Initilizing from My Scope device...\n");
+
+    init_properties();
+
+ }
+
+/**************************************************************************************
+**
+***************************************************************************************/
+MyScope::~MyScope()
+{
+
+}
+
+/**************************************************************************************
+** Initialize all properties & set default values.
+***************************************************************************************/
+void MyScope::init_properties()
+{
+    // This is the default driver skeleton file location
+    // Convention is: drivername_sk_xml
+    // Default location is /usr/share/indi
+    const char *skelFileName = "/usr/share/indi/tutorial_four_sk.xml";
+    struct stat st;
+
+
+    char *skel = getenv("INDISKEL");
+    if (skel)
+        buildSkeleton(skel);
+    else if (stat(skelFileName,&st) == 0)
+        buildSkeleton(skelFileName);
+    else
+        IDLog("No skeleton file was specified. Set environment variable INDISKEL to the skeleton path and try again.\n");
+
+    // Optional: Add aux controls for configuration, debug & simulation that get added in the Options tab
+    //           of the driver.
+    addAuxControls();
+
+}
+
+/**************************************************************************************
+** Define Basic properties to clients.
+***************************************************************************************/
+void MyScope::ISGetProperties(const char *dev)
+{
+    static int configLoaded = 0;
+
+    // Ask the default driver first to send properties.
+    INDI::DefaultDriver::ISGetProperties(dev);
+
+    // If no configuration is load before, then load it now.
+    if (configLoaded == 0)
+    {
+      loadConfig();
+      configLoaded = 1;
+    }
+
+}
+
+/**************************************************************************************
+** Process Text properties
+***************************************************************************************/
+bool MyScope::ISNewText (const char *dev, const char *name, char *texts[], char *names[], int n)
+{
+	// Ignore if not ours 
+        if (strcmp (dev, deviceID))
+            return false;
+
+        return false;
+}
+
+/**************************************************************************************
+**
+***************************************************************************************/
+bool MyScope::ISNewNumber (const char *dev, const char *name, double values[], char *names[], int n)
+{
+	
+	// Ignore if not ours
+        if (strcmp (dev, deviceID))
+            return false;
+
+        INumberVectorProperty *nvp = getNumber(name);
+
+        if (!nvp)
+            return false;
+
+        // Are we updating Slew Accuracy?
+        if (!strcmp(nvp->name, "Slew Accuracy"))
+        {
+            IUUpdateNumber(nvp, values, names, n);
+            nvp->s = IPS_OK;
+            IDSetNumber(nvp, NULL);
+
+            return true;
+        }
+
+        return false;
+}
+
+/**************************************************************************************
+**
+***************************************************************************************/
+bool MyScope::ISNewSwitch (const char *dev, const char *name, ISState *states, char *names[], int n)
+{
+	// ignore if not ours //
+        if (strcmp (dev, deviceID))
+            return false;
+
+        if (INDI::DefaultDriver::ISNewSwitch(dev, name, states, names, n) == true)
+            return true;
+
+        ISwitchVectorProperty *svp = getSwitch(name);
+
+        if (!svp)
+            return false;
+
+        // Are we update CONNECTION?
+        if (!strcmp(svp->name, "CONNECTION"))
+        {
+            IUUpdateSwitch(svp, states, names, n);
+            connect_telescope();
+            return true;
+        }
+
+
+}
+
+
+/**************************************************************************************
+**
+***************************************************************************************/
+void MyScope::connect_telescope()
+{
+    ISwitchVectorProperty *svp = getSwitch("CONNECTION");
+
+    ISwitch *sp = IUFindOnSwitch(svp);
+
+    if (!sp)
+        return;
+
+    // Are we connecting?
+    if (!strcmp(sp->name, "CONNECT"))
+    {
+        // Make sure to call setConnected(true) before informing client about successful connection
+        setConnected(true);
+        IDSetSwitch(svp, "Connecting.... telescope is online.");
+        IDLog("Connecting.... telescope is online.\n");
+
+
+    }
+    // Are we disconnecting?
+    else
+    {
+        setConnected(false);
+        IDSetSwitch(svp, "Disconnecting... telescope is offline.");
+        IDLog("Disconnecting... telescope is offline.\n");
+    }
+}
+
+
Index: /BAORadio/libindi/libindi/examples/tutorial_four.h
===================================================================
--- /BAORadio/libindi/libindi/examples/tutorial_four.h	(revision 501)
+++ /BAORadio/libindi/libindi/examples/tutorial_four.h	(revision 501)
@@ -0,0 +1,45 @@
+/*
+    Tutorial Four
+    Copyright (C) 2010 Jasem Mutlaq (mutlaqja@ikarustech.com)
+
+    This library is free software; you can redistribute it and/or
+    modify it under the terms of the GNU Lesser General Public
+    License as published by the Free Software Foundation; either
+    version 2.1 of the License, or (at your option) any later version.
+
+    This library is distributed in the hope that it will be useful,
+    but WITHOUT ANY WARRANTY; without even the implied warranty of
+    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
+    Lesser General Public License for more details.
+
+    You should have received a copy of the GNU Lesser General Public
+    License along with this library; if not, write to the Free Software
+    Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301  USA
+
+*/
+
+#ifndef TUTORIAL_FOUR_H
+#define TUTORIAL_FOUR_H
+
+#include "indidevapi.h"
+#include "indicom.h"
+#include "indibase/defaultdriver.h"
+
+class MyScope : public INDI::DefaultDriver
+{
+ public:
+ MyScope();
+ ~MyScope();
+
+ virtual void ISGetProperties (const char *dev);
+ virtual bool ISNewNumber (const char *dev, const char *name, double values[], char *names[], int n);
+ virtual bool ISNewText (const char *dev, const char *name, char *texts[], char *names[], int n);
+ virtual bool ISNewSwitch (const char *dev, const char *name, ISState *states, char *names[], int n);
+
+private:
+ void init_properties();
+ void connect_telescope();
+
+};
+
+#endif
Index: /BAORadio/libindi/libindi/examples/tutorial_two.c
===================================================================
--- /BAORadio/libindi/libindi/examples/tutorial_two.c	(revision 500)
+++ /BAORadio/libindi/libindi/examples/tutorial_two.c	(revision 501)
@@ -100,6 +100,6 @@
 
 /* Equatorial EOD Coord Request. This property is for requesting changes to target equatorial coordinates. However, the CURRENT coordinates are reported in EQUATORIAL_EOD_COORDS above.*/
-static INumber eqNR[] = {{"RA_REQUEST" ,"RA  H:M:S" , "%10.6m" ,0. , 24., 0., 0., 0, 0, 0},
-			 {"DEC_REQUEST", "Dec D:M:S", "%10.6m", -90., 90., 0., 0., 0, 0, 0}};
+static INumber eqNR[] = {{"RA" ,"RA  H:M:S" , "%10.6m" ,0. , 24., 0., 0., 0, 0, 0},
+			 {"DEC", "Dec D:M:S", "%10.6m", -90., 90., 0., 0., 0, 0, 0}};
 static INumberVectorProperty eqNPR = {  mydev, "EQUATORIAL_EOD_COORD_REQUEST", "Equatorial Request",  MAIN_GROUP , IP_RW, 0, IPS_IDLE,  eqNR, NARRAY(eqNR), "", 0};
 
Index: /BAORadio/libindi/libindi/indiapi.h
===================================================================
--- /BAORadio/libindi/libindi/indiapi.h	(revision 500)
+++ /BAORadio/libindi/libindi/indiapi.h	(revision 501)
@@ -48,5 +48,6 @@
 <li><a href="indicom_8h.html">INDI Common Routine Library</a></li>
 <li><a href="lilxml_8h.html">INDI LilXML Library</a></li>
-<li><a href="http://heasarc.gsfc.nasa.gov/docs/software/fitsio/c/c_user/cfitsio.html">CFITSIO Library</a></li>
+<li><a href="group__configFunctions.html">Configuration</a></li>
+<li><a href="classINDI_1_1BaseClient.html">Client API</a></li>
 </ul>
 
@@ -74,5 +75,5 @@
 
 /* INDI Library version */
-#define INDI_LIBV	0.6
+#define INDI_LIBV	0.7
 
 /*******************************************************************************
Index: /BAORadio/libindi/libindi/indidevapi.h
===================================================================
--- /BAORadio/libindi/libindi/indidevapi.h	(revision 500)
+++ /BAORadio/libindi/libindi/indidevapi.h	(revision 501)
@@ -302,8 +302,8 @@
     \param snooped_property name of the snooped property in the device.
 */
-extern void IDSnoopDevice (const char *snooped_device, char *snooped_property);
+extern void IDSnoopDevice (const char *snooped_device, const char *snooped_property);
 
 /** \brief Function a Driver calls to control whether they will receive BLOBs from snooped devices.
-    \param snooped_device_name name of the device to snoop.
+    \param snooped_device name of the device to snoop.
     \param bh How drivers handle BLOBs incoming from snooping drivers.
 */
@@ -403,25 +403,41 @@
 /** \brief Find an IText member in a vector text property.
 *
-* \param tp a pointer to a text vector property.
+* \param tvp a pointer to a text vector property.
 * \param name the name of the member to search for.
 * \return a pointer to an IText member on match, or NULL if nothing is found.
 */
-extern IText   *IUFindText  (const ITextVectorProperty *tp, const char *name);
+extern IText   *IUFindText  (const ITextVectorProperty *tvp, const char *name);
 
 /** \brief Find an INumber member in a number text property.
 *
-* \param tp a pointer to a number vector property.
+* \param nvp a pointer to a number vector property.
 * \param name the name of the member to search for.
 * \return a pointer to an INumber member on match, or NULL if nothing is found.
 */
-extern INumber *IUFindNumber(const INumberVectorProperty *tp, const char *name);
+extern INumber *IUFindNumber(const INumberVectorProperty *nvp, const char *name);
 
 /** \brief Find an ISwitch member in a vector switch property.
 *
-* \param tp a pointer to a switch vector property.
+* \param svp a pointer to a switch vector property.
 * \param name the name of the member to search for.
 * \return a pointer to an ISwitch member on match, or NULL if nothing is found.
 */
-extern ISwitch *IUFindSwitch(const ISwitchVectorProperty *tp, const char *name);
+extern ISwitch *IUFindSwitch(const ISwitchVectorProperty *svp, const char *name);
+
+/** \brief Find an ILight member in a vector Light property.
+*
+* \param lvp a pointer to a Light vector property.
+* \param name the name of the member to search for.
+* \return a pointer to an ILight member on match, or NULL if nothing is found.
+*/
+extern ILight *IUFindLight(const ILightVectorProperty *lvp, const char *name);
+
+/** \brief Find an IBLOB member in a vector BLOB property.
+*
+* \param bvp a pointer to a BLOB vector property.
+* \param name the name of the member to search for.
+* \return a pointer to an IBLOB member on match, or NULL if nothing is found.
+*/
+extern IBLOB *IUFindBLOB(const IBLOBVectorProperty *bvp, const char *name);
 
 /** \brief Returns the first ON switch it finds in the vector switch property.
@@ -429,8 +445,8 @@
 *   \note This is only valid for ISR_1OFMANY mode. That is, when only one switch out of many is allowed to be ON. Do not use this function if you can have multiple ON switches in the same vector property.
 *        
-* \param tp a pointer to a switch vector property.
+* \param sp a pointer to a switch vector property.
 * \return a pointer to the \e first ON ISwitch member if found. If all switches are off, NULL is returned. 
 */
-extern ISwitch *IUFindOnSwitch (const ISwitchVectorProperty *tp);
+extern ISwitch *IUFindOnSwitch (const ISwitchVectorProperty *sp);
 
 /** \brief Reset all switches in a switch vector property to OFF.
@@ -517,4 +533,11 @@
 extern void IUFillText(IText *tp, const char *name, const char * label, const char *initialText);
 
+/** \brief Assign attributes for a BLOB property. The BLOB's data and auxiliary elements will be set to NULL.
+    \param bp pointer a BLOB property to fill
+    \param name the BLOB name
+    \param label the BLOB label
+    \param format the BLOB format.
+*/
+extern void IUFillBLOB(IBLOB *bp, const char *name, const char * label, const char *format);
 
 /** \brief Assign attributes for a switch vector property. The vector's auxiliary elements will be set to NULL.
@@ -573,4 +596,19 @@
 extern void IUFillTextVector(ITextVectorProperty *tvp, IText *tp, int ntp, const char * dev, const char *name, const char *label, const char* group, IPerm p, double timeout, IPState s);
 
+/** \brief Assign attributes for a BLOB vector property. The vector's auxiliary elements will be set to NULL.
+    \param bvp pointer a BLOB vector property to fill
+    \param bp pointer to an array of BLOBs
+    \param nbp the dimension of bp
+    \param dev the device name this vector property belongs to
+    \param name the vector property name
+    \param label the vector property label
+    \param group the vector property group
+    \param p the vector property permission
+    \param timeout vector property timeout in seconds
+    \param s the vector property initial state.
+*/
+extern void IUFillBLOBVector(IBLOBVectorProperty *bvp, IBLOB *bp, int nbp, const char * dev, const char *name, const char *label, const char* group, IPerm p, double timeout, IPState s);
+
+
 /** \brief Update a snooped number vector property from the given XML root element.
     \param root XML root elememnt containing the snopped property content
@@ -706,4 +744,54 @@
 #define INDI_UNUSED(x) (void) x
 
+/** \brief Extract dev and name attributes from an XML element.
+    \param root The XML element to be parsed.
+    \param dev pointer to an allocated buffer to save the extracted element device name attribute.
+           The buffer size must be at least MAXINDIDEVICE bytes.
+    \param name pointer to an allocated buffer to save the extracted elemented name attribute.
+           The buffer size must be at least MAXINDINAME bytes.
+    \param msg pointer to an allocated char buffer to store error messages. The minimum buffer size is MAXRBUF.
+    \return 0 if successful, -1 if error is encountered and msg is set.
+*/
+extern int crackDN (XMLEle *root, char **dev, char **name, char msg[]);
+
+/** \brief Extract property state (Idle, OK, Busy, Alert) from the supplied string.
+    \param str A string representation of the state.
+    \param ip Pointer to IPState structure to store the extracted property state.
+    \return 0 if successful, -1 if error is encountered.
+*/
+extern int crackIPState (const char *str, IPState *ip);
+
+/** \brief Extract switch state (On or Off) from the supplied string.
+    \param str A string representation of the switch state.
+    \param ip Pointer to ISState structure to store the extracted switch state.
+    \return 0 if successful, -1 if error is encountered.
+*/
+extern int crackISState (const char *str, ISState *ip);
+
+/** \brief Extract property permission state (RW, RO, WO) from the supplied string.
+    \param str A string representation of the permission state.
+    \param ip Pointer to IPerm structure to store the extracted permission state.
+    \return 0 if successful, -1 if error is encountered.
+*/
+extern int crackIPerm (const char *str, IPerm *ip);
+
+/** \brief Extract switch rule (OneOfMany, OnlyOne..etc) from the supplied string.
+    \param str A string representation of the switch rule.
+    \param ip Pointer to ISRule structure to store the extracted switch rule.
+    \return 0 if successful, -1 if error is encountered.
+*/
+extern int crackISRule (const char *str, ISRule *ip);
+
+/** \return Returns a string representation of the supplied property state. */
+extern const char *pstateStr(IPState s);
+/** \return Returns a string representation of the supplied switch status. */
+extern const char *sstateStr(ISState s);
+/** \return Returns a string representation of the supplied switch rule. */
+extern const char *ruleStr(ISRule r);
+/** \return Returns a string representation of the supplied permission value. */
+extern const char *permStr(IPerm p);
+
+extern void xmlv1(void);
+
 #ifdef __cplusplus
 }
